// SampleAppDlg.h : header file
//

#if !defined(AFX_SAMPLEAPPDLG_H__DF8AD592_E2F5_4011_911B_993892F681F9__INCLUDED_)
#define AFX_SAMPLEAPPDLG_H__DF8AD592_E2F5_4011_911B_993892F681F9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Omcr.H"

/////////////////////////////////////////////////////////////////////////////
// CSampleAppDlg dialog

class CSampleAppDlg : public CDialog
{
	//Pointer of Card Reader
	LPCOMCR lpcOmcr;
	HANDLE m_hReadThread;

private:
	//API Handling Functions
	BOOL OpenDevice();
	DWORD CloseDevice();
	DWORD Activate();
	DWORD Deactivate();
	DWORD CSampleAppDlg::ICCRead();
	void CSampleAppDlg::ICCWrite();
	void CSampleAppDlg::sec1();
	void CSampleAppDlg::Sec2();
	void CSampleAppDlg::Sec4();
	void CSampleAppDlg::msec250();
	void CSampleAppDlg::msec500();
	void CSampleAppDlg::sec0();
	
	void ChangeReadDirection(int nDir);
	void StartReading();
	void StopReading();

	// User Interface Functions
	void EnableButtons();
	void DisableButtons();
	void ChangeToActivate();
	void ChangeToDeactivate();
	void EnableReadButton();
	void DisableReadButton();

// Construction
public:
	CSampleAppDlg(CWnd* pParent = NULL);	// standard constructor
	LPCOMCR	GetOmcr()	{	return lpcOmcr;	}

	// Display Data Functions
	void DisplayReadData(LPCOMCR_MAGTRACK lpcMagTrack);
	void DisplayErrorMessage(CString strApiName, DWORD dwErrorCode);
	void DisplayStatus(CString strStatus);
	void DisplayReadStatus();

// Dialog Data
	//{{AFX_DATA(CSampleAppDlg)
	enum { IDD = IDD_SAMPLEAPP_DIALOG };
	CEdit	m_edtStatus;
	CString	m_strSerialNumber;
	CString	m_strReadData;
	int		m_nReadDirection;
	CString	m_strDevice;
	CString	m_strICData;
	CString	m_strICCRW;
	CString	m_strICWriteD;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSampleAppDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CSampleAppDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnBUTTONOpenDevice();
	afx_msg void OnBUTTONCloseDevice();
	afx_msg void OnBUTTONInitialReset();
	afx_msg void OnBUTTONActivateICC();
	afx_msg void OnDestroy();
	afx_msg void OnRADIOInsertion();
	afx_msg void OnRADIOBack();
	afx_msg void OnDisplayReadData(WPARAM wParam, LPARAM lParam);
	afx_msg void OnDisplayStatus(WPARAM wParam, LPARAM lParam);
	afx_msg void OnBUTTONICCRead();
	afx_msg void OnBUTTONICCWrite();
	afx_msg void OnButtonLedG();
	afx_msg void OnRADIO1sec();
	afx_msg void OnButtonLedR();
	afx_msg void OnButtonLedgO();
	afx_msg void OnRADIOInsertion3();
	afx_msg void OnRADIOSec2();
	afx_msg void OnRADIOSec4();
	afx_msg void OnRADIOmsec500();
	afx_msg void OnRADIOmsec250();
	afx_msg void OnRADIOsec0();
	afx_msg void OnButtonLedout();
	afx_msg void OnBUTTONInsertion();
	afx_msg void OnBUTTONBack();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SAMPLEAPPDLG_H__DF8AD592_E2F5_4011_911B_993892F681F9__INCLUDED_)
